<?php
/*******************************************************************
 *			
 * 			Fichier         :	class.mailer.php 
 * 			Cr le         :	29 juin 2002 
 * 			Dernire modif  :	15 mai 2003 
 * 			Email           :	wascripts@phpcodeur.net 
 * 
 * 				Copyright  2002-2003 phpCodeur - WAmailer 2.0
 * 
 *******************************************************************/

/*******************************************************************
 *  This program is free software; you can redistribute it and/or 
 * 	modify it under the terms of the GNU General Public License as 
 * 	published by the Free Software Foundation; either version 2 of 
 *  the License, or (at your option) any later version. 
 *******************************************************************/


/*
 *  Classe d'envoi d'emails 
 *  Fonctionne galement sur Online et Nexen 
 *  Gre l'attachement de pices jointes et l'envoi d'emails au format html, 
 *  ainsi que les emails multi-formats. 
 *  Gre aussi les pices jointes dites "embarques" 
 *  (incorpores et utilises dans l'email html, ex: images, sons ..)
 *
 */
if( !defined('CLASS_MAILER_INC') )
{

define('CLASS_MAILER_INC', 1); 

define('WM_HOST_OTHER', 1); 
define('WM_HOST_ONLINE', 2); 
define('WM_HOST_NEXEN', 3); 

class Mailer {
	
	/*
     * Chemins par dfaut pour les modles d'emails 
     *
     * @var	(string)	$root
	 * 
	 * @access public
     */
	var $root				= './'; 
	
	/*
     * Vous devez dfinir la fonction mail qu'utilise votre hbergeur 
	 * 
	 * 1 ou WM_HOST_OTHER pour la fonction mail() classique
	 * 2 ou WM_HOST_ONLINE pour la fonction email() de online
	 * 3 ou WM_HOST_NEXEN pour la fonction email() de nexen 
     *
     * @var	(integer)	$hebergeur
	 * 
	 * @access public
     */
	var $hebergeur 			= WM_HOST_OTHER; 
	
	/*
     * Format de l'email 
	 * 
	 * 1 - pour format texte brut
	 * 2 - pour format html
	 * 3 - Double format (html affich, et texte si html pas support)
	 * 
     * @var	(integer)	$format
	 * 
	 * @access public
     */
	var $format				= 1; 
	
	/*
     * Activation du mode smtp
	 * 
     * @var	(booleen)	$smtp_mode
	 * 
	 * @access public
     */
	var $smtp_mode 			= false; 
	
	/*
     * Remplissez le tableau pour indiquer au script les donnes qui lui permettront de se 
	 * connecter au serveur.
	 * 
     * @var	(array)		$smtp_data
	 * 						host -> nom ou ip du serveur smtp (ex: smtp.wanadoo.fr)
	 * 						port -> port utilis (en gnral 25)
	 * 						user -> login pour la connexion (seulement si ncessaire)
	 * 						pass -> password pour la connexion (seulement si ncessaire)
	 * 
	 * @access public
     */
	var $smtp_data			= array(
			'host' => '', 
			'port' => 25, 
			'user' => '', 
			'pass' => '' 
		);
	
	/*
     * Adresse de l'expditeur 
	 * 
     * @var	(array)		$from
	 * @var	(string)	$from_online
	 * @var	(string)	$reply_online
	 * 
	 * @access public
     */
	var $from 				= array('email' => '', 'name' => ''); 
	var $from_online		= ''; 
	var $reply_online		= ''; 
	
	/*
     * Tableau des adresses des destinataires
	 * 
     * @var	(array)		$address
	 * 
	 * @access public
     */
	var $address			= array(); 
	
	/*
     * Sujet de l'email
	 * 
     * @var	(string)	$subject
	 * 
	 * @access public
     */
	var $subject 			= ''; 
	
	/*
     * Variables contenant le message non compil, compil, et les tags  remplacer dans le texte 
	 * 
     * @var	(string)	$uncompiled_message
	 * @var	(string)	$uncompiled_altmessage
	 * @var	(string)	$compiled_message
	 * @var	(array)		$tags
	 * @var (array)		$boundary
	 * 
	 * @access private
     */
	var $uncompiled_message		= array(); 
	var $uncompiled_altmessage	= array(); 
	var $compiled_message		= array(); 
	var $tags					= array(); 
	var $block_tags				= array(); 
	var $boundary				= array('part0' => '', 'part1' => '', 'part2' => ''); 
	
	/*
     * Tableau des fichiers attachs
	 * 
     * @var	(array)		$attachfile
	 * @var	(array)		$embeddedfile
	 * 
	 * @access private
     */	
	var $attachfile 			= array(
			'path'		  => array(),
			'name'		  => array(),			
			'mimetype'	  => array(),
			'disposition' => array()
		); 
	
	var $embeddedfile 			= array(
			'path'		  => array(),
			'name'		  => array(),
			'mimetype'	  => array()
		); 
	
	/*
     * Tableau des enttes de l'email
	 * 
     * @var	(array)		$headers
	 * 
	 * @access private
     */
	var $headers 		= array(); 
	
	/*
     * Jeu de caractre utilis pour l'email
	 * 
     * @var	(string)	$charset
	 * 
	 * @access public
     */	
	var $charset 			= 'iso-8859-1'; 
	
	/*
     * Encodage  utiliser 
	 * (7bit, 8bit, quoted-printable, base64 ou binary)
	 * 
     * @var	(string)	$encoding
	 * 
	 * @access public
     */
	var $encoding			= 'quoted-printable'; 
	
	/*
     * Nom du serveur metteur
	 * 
     * @var	(string)	$server
	 * 
	 * @access public
     */
	var $server				= 'localhost'; 
	
	/*
     * Eventuels messages d'erreur
	 * 
     * @var	(string)	$mail_reponse
	 * 
	 * @access private
     */
	var $mail_reponse		= ''; // Variable contenant le message d'erreur en cas d'chec de l'envoi.
	
	/*
     * Activer/dsactiver le mode de dbogguage
	 * S'il est activ, les messages d'erreur s'afficheront directement  l'cran et l'xcution du script 
	 * sera interrompu
	 * 
     * @var	(booleen)	$debug
	 * 
	 * @access public
     */
	var $debug 				= true; 
	
	/*
     * Statut du traitement de l'envoi
	 * Cette variable ne doit pas tre modifie, si elle est  false, 
	 * l'email n'est tout simplement pas envoy
	 * 
     * @var	(booleen)	$statut
	 * 
	 * @access private
     */
	var $statut				= true; // ne pas modifier ! 
	
	/*
     * Version actuelle de la classe
	 * 
     * @var	(string)	$version
	 * 
	 * @access private
     */
	var $version			= '2.0'; 
	
	
	/*
	 * Mailer : Mailer()
	 * 
	 * @param (string) 	$template_path	: Chemin vers les modles d'emails 
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function Mailer($template_path = '')
	{
		if( $template_path != '' )
		{
			$this->set_root($template_path); 
		}
	}
	
	/*
	 * Mailer : set_root()
	 * 
	 * @param (string) $template_path	: Chemin vers les modles 
	 * @param (string) $tpl_type		: Type des modles (texte ou html) 
	 * 
	 * @access public
	 * 
	 * @return boolean
	 */
	function set_root($template_path)
	{
		$template_path = preg_replace('/^(.*?)\/?$/', '\\1', $template_path); 
		
		if( !@file_exists($template_path) || !@is_dir($template_path) )
		{
			$this->error('set_path_template()', "Le chemin \"$template_path/\" est incorrect."); 
			return false; 
		}
		
		$this->root = $template_path . '/'; 
		
		return true; 
	}
	
	/*
	 * Mailer : set_smtp()
	 * 
	 * @param (string) 	$host		: Nom du serveur SMTP
	 * @param (integer) $port		: Port de connexion ( 25 dans la grande majorit des cas )
	 * @param (string) 	$user		: Login d'authentification ( si AUTH est support par le serveur )
	 * @param (string) 	$pass		: Password d'authentification ( si AUTH est support par le serveur )
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function set_smtp($host = '', $port = '', $user = '', $pass = '')
	{
		$this->smtp_mode = true; 
		
		$this->smtp_data['host'] = ( $host != '' ) ? $host : $this->smtp_data['host']; 
		$this->smtp_data['port'] = ( $port != '' ) ? $port : $this->smtp_data['port']; 
		$this->smtp_data['user'] = ( $user != '' ) ? $user : $this->smtp_data['user']; 
		$this->smtp_data['pass'] = ( $pass != '' ) ? $pass : $this->smtp_data['pass']; 		
	}
	
	/*
	 * Mailer : set_from()
	 * 
	 * @param (string) 	$email_from	: Email de l'expditeur
	 * @param (string) 	$name_from 	: Personnalisation du nom de l'expditeur
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function set_from($email_from, $name_from = '')
	{
		$this->from['email'] = trim($email_from); 
		$this->from['name']  = trim($name_from); 
		
		$this->headers['From']     	  = ( ( $this->from['name'] != '' ) ? '"' . $this->from['name'] . '" ' : '' ) . '<' . $this->from['email'] . '>'; 
		$this->headers['X-Sender'] 	  = '<' . $this->from['email'] . '>'; 
		$this->headers['Reply-To'] 	  = '<' . $this->from['email'] . '>'; 
		$this->headers['Return-Path'] = $this->from['email']; 
	}
	
	/*
	 * Mailer : set_to()
	 * 
	 * @param (string/array)$email_mixed	: Email du destinataire ou tableau contenant la liste des destinataires 
	 * @param (string) 		$type			: Type de destinataire : to, cc, ou bcc
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function set_to($email_mixed, $type = '')
	{
		$type = ucfirst(strtolower($type)); 
		if( $type != 'Cc' && $type != 'Bcc' )
		{
			$type = 'To'; 
		}
		
		if( !is_array($email_mixed) )
		{
			$email_mixed = array($email_mixed); 
		}
		
		$address_ary = array(); 
		foreach( $email_mixed AS $name_to => $email )
		{
			$name_to = ( !is_numeric($name_to) ) ? trim($name_to) : ''; 
			
			$this->address[] = trim($email); 
			
			$address_ary[] = ( ( $name_to != '' ) ? '"' . $name_to . '" ' : '' ) . '<' . trim($email) . '>'; 
		}
		
		if( !isset($this->headers[$type]) )
		{
			$this->headers[$type] = ''; 
		}
		
		if( $this->headers[$type] != '' )
		{
			$this->headers[$type] .= ', '; 
		}
		
		$this->headers[$type] .= implode(', ', $address_ary); 
	}
	
	/*
	 * Mailer : set_subject()
	 * 
	 * @param (string)	$subject			: Le sujet de l'email
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function set_subject($subject)
	{
		$this->subject = trim($subject); 
		$this->subject = preg_replace("/[\t\r\n]/", '', trim($this->subject)); 
		$this->subject = '=?' . $this->charset . '?Q?' . $this->make_encoding('quoted-printable', $this->subject) . '?='; 
		
		$this->headers['Subject'] = $this->subject; 
	}
	
	/*
	 * Mailer : set_message()
	 * 
	 * @param (string)	$message			: contient le message  envoyer
	 * @param (array)	$tags_ary			: Variables  remplacer dans le texte
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function set_message($message, $tags_ary = '')
	{
		$this->compiled_message[$this->format]	 = ''; 
		$this->uncompiled_message[$this->format] = trim($message); 
		
		$this->assign_tags($tags_ary); 		
	}
	
	/*
	 * Mailer : set_altmessage()
	 * 
	 * @param (string)	$message 			: contient le message alternatif
	 * @param (array)	$tags_ary			: Variables  remplacer dans le texte
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function set_altmessage($message, $tags_ary = '')
	{
		$this->uncompiled_altmessage[$this->format] = trim($message); 
		
		$this->assign_tags($tags_ary); 
	}
	
	/*
	 * Mailer : use_template()
	 * 
	 * @param (string) 	$file				: Nom du modle (sans l'extension)
	 * @param (array)	$tags_ary			: Variables  remplacer dans le texte
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function use_template($file, $tags_ary = '')
	{
		$this->compiled_message[$this->format] = ''; 
		
		if( !$this->set_root($this->root) )
		{
			return false; 
		}
		
		if( ( $this->format == 3 || $this->format == 1 ) && $this->set_file($this->root . $file . '.txt') )
		{
			$eval  = ( $this->format == 3 ) ? '$this->uncompiled_altmessage' : '$this->uncompiled_message'; 
			$eval .= '[$this->format] = $this->loadfile($this->root . $file . \'.txt\');'; 
			
			eval($eval); 
		}
		
		if( ( $this->format == 3 || $this->format == 2 ) && $this->set_file($this->root . $file . '.html') )
		{
			$this->uncompiled_message[$this->format] = $this->loadfile($this->root . $file . '.html'); 
		}
		
		$this->assign_tags($tags_ary); 
		
		return true; 
	}
	
	/*
	 * Mailer : assign_tags()
	 * 
	 * @param (array)	$tags_ary			: tableau des tags  remplacer dans le message
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function assign_tags($tags_ary)
	{
		if( is_array($tags_ary) )
		{
			foreach( $tags_ary AS $key => $val )
			{
				if( preg_match('/^[[:alnum:]_-]+$/i', $key) )
				{
					$this->tags[$key] = $val; 
				}
			}
		}
	}
	
	/*
	 * Mailer : assign_block_tags()
	 * 
	 * @param (array)	$block_name			: Nom du block et des ventuels sous blocks
	 * @param (array)	$tags_ary			: tableau des tags  remplacer dans le message
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function assign_block_tags($block_name, $tags_ary = '')
	{
		$this->block_tags[$block_name] = array(); 
		
		if( is_array($tags_ary) )
		{
			foreach( $tags_ary AS $key => $val )
			{
				if( preg_match('/^[[:alnum:]_-]+$/i', $key) )
				{
					$this->block_tags[$block_name][$key] = $val; 
				}
			}
		}
	}
	
	/*
	 * Mailer : replace_tags()
	 * 
	 * @param (string)	$texte	
	 * 
	 * @access private
	 * 
	 * @return string
	 */
	function replace_tags($texte)
	{
		$keys = $values = array(); 
		foreach( $this->tags AS $key => $val )
		{
			$keys[]	  = '/(%|\{)'.$key.'(%|\})/'; 
			$values[] = $val; 
		}
		
		$texte = preg_replace($keys, $values, $texte); 
		
		return $this->replace_block_tags($texte); 
	}
	
	/*
	 * Mailer : replace_block_tags()
	 * 
	 * @param (string)	$texte	
	 * 
	 * @access private
	 * 
	 * @return string
	 */
	function replace_block_tags($texte)
	{
		preg_match_all(
			"/<!--[ ]+start_block[ ]+([a-zA-Z0-9_-]+)[ ]+-->(?:\r)?\n(.*?)(?:\r)?\n<!--[ ]+end_block[ ]+\\1[ ]+-->(?:(?:\r)?\n)?/s",
			$texte,
			$matches
		); 
		
		$total_blocks = count($matches[1]); 
		
		for( $i = 0; $i < $total_blocks; $i++ )
		{
			$block_name = $matches[1][$i]; 
			$tmp = ''; 
			
			if( isset($this->block_tags[$block_name]) )
			{
				$keys = $values = array(); 
				foreach( $this->block_tags[$block_name] AS $key => $val )
				{
					$keys[]	  = '/(%|\{)' . $block_name . '.' . $key . '(%|\})/'; 
					$values[] = $val; 
				}
				
				$tmp = preg_replace($keys, $values, $matches[2][$i]); 
			}
			
			$texte = str_replace($matches[0][$i], $tmp, $texte); 
		}
		
		return $texte; 
	}
	
	/*
	 * Mailer : set_file()
	 * 
	 * @param (string)	$path				: Chemin vers le fichier
	 * 
	 * @access private
	 * 
	 * @return boolean
	 */
	function set_file($path)
	{
		if( !@file_exists($path) )
		{
			$this->error('set_file()', 'Le fichier "' . basename($path) . '" est introuvable'); 
			
			return false; 
		}
		else if( !@is_readable($path) )
		{
			$this->error('set_file()', 'Le fichier "' . basename($path) . '" n\'est pas accessible en lecture'); 
			
			return false; 
		}
		
		return true; 
	}
	
	/*
	 * Mailer : loadfile()
	 * 
	 * @param (string)	$path 				: Chemin vers le fichier
	 * @param (boolean)	$binary_file 		: On spcifie si on charge un fichier binaire (pour windows)
	 * 
	 * @access public
	 * 
	 * @return string
	 */
	function loadfile($path, $binary_file = false)
	{
		$mode = ( $binary_file ) ? 'rb' : 'r'; 
		
		if( !($fp = @fopen($path, $mode)) )
		{
			$this->error('loadfile()', 'Lecture du fichier "' . basename($path) . '" impossible'); 
			return false;
		}
		
		$contents = fread($fp, filesize($path)); 
		fclose($fp); 
		
		return $contents; 
	}
	
	/* 
	 * Mailer : make_encoding()
	 * 
	 * @param string $encoding	: Type d'encodage dsir
	 * @param string $str		: Chane  encoder
	 * 
	 * @access public
	 * 
	 * @return string
	 */
	function make_encoding($encoding, $str)
	{
		switch($encoding)
		{
			case '7bit':
			case '8bit':
				$str = preg_replace("/(\r(?!\n)|\r\n)/", "\n", $str); 
				break;
			
			case 'base64':
				$str = chunk_split(base64_encode($str)); 
				break;
			
			case 'quoted-printable':
				$str = preg_replace("/(\r(?!\n)|\r\n)/", "\n", $str); 
				
				if( @extension_loaded('imap') && @function_exists('imap_8bit') )
				{
					$str = imap_8bit($str); 
				}
				else
				{
					$str = preg_replace('/([\000-\010\013\014\016-\037\075\177-\377])/e', "'=' . sprintf('%02X', ord('\\1'));", $str); 
				}
				break;
		}
		
		return $str; 
	}
	
	/*
	 * Mailer : attachment()
	 * 
	 * @param string $path			: Chemin vers le fichier
	 * @param string $filename		: Nom du fichier
	 * @param string $disposition	: Disposition
	 * @param string $mime_type		: Mime-type
	 * @param bool	 $embedded		: true si fichier incorpor dans l'email html
	 * 
	 * @access public
	 *  
	 * @return void
	 */
	function attachment($path, $filename = '', $disposition = '', $mime_type = '', $embedded = false)
	{
		$this->compiled_message[$this->format] = ''; 
		
		if( !$this->set_file($path) )
		{
			return;
		}
		
		if( $embedded )
		{
			$this->embeddedfile['path'][] 		= $path; 
			$this->embeddedfile['name'][] 		= ( $filename != '' ) ? trim($filename) : basename($path); 
			$this->embeddedfile['mimetype'][] 	= $mime_type; 
		}
		else
		{
			$this->attachfile['path'][] 		= $path; 
			$this->attachfile['name'][] 		= ( $filename != '' ) ? trim($filename) : basename($path); 
			$this->attachfile['mimetype'][] 	= $mime_type; 
			$this->attachfile['disposition'][] 	= ( $disposition == 'inline' ) ? 'inline' : 'attachment'; 				
		}		
	}
	
	/*
	 * Mailer : generate_cid()
	 * 
	 * @access private
	 *  
	 * @return string
	 */	
	function generate_cid()
	{
		$chars = array(
			'A', 'a', 'B', 'b', 'C', 'c', 'D', 'd', 'E', 'e', 'F', 'f', 'G', 'g', 'H', 'h', 'I', 'i', 'J', 'j', 
			'K', 'k', 'L', 'l', 'M', 'm', 'N', 'n', 'O', 'o', 'P', 'p', 'Q', 'q', 'R', 'r', 'S', 's', 'T', 't', 
			'U', 'u', 'V', 'v', 'W', 'w', 'X', 'x', 'Y', 'y', 'Z', 'z', '2', '3', '4', '5', '6', '7', '8', '9', '0'
		); 
		
		$max_chars = count($chars) - 1; 
		srand( (double) microtime()*1000000);
		
		$cid = ''; 
		for( $i = 0; $i < 30; $i++ )
		{
			$cid .= $chars[rand(0, $max_chars)]; 
		}
		
		return $cid . '@wamailer'; 
	}
	
	/*
	 * Mailer : mime_type()
	 * 
	 * @param string $ext 	: Extension de fichier
	 * 
	 * @access public
	 * 
	 * @return string
	 */
	function mime_type($ext)
	{
		//
		// Tableau des extensions et de leur Mime-Type
		// Rien ne vous interdit d'en rajouter si besoin est.
		//
		$mime_type_ary = array(
			'txt'  => 'text/plain', 
			'rtx'  => 'text/richtext', 
			'html' => 'text/html', 
			'htm'  => 'text/html', 
			'xml'  => 'text/xml', 
			'xls'  => 'text/xml', 
			'tsv'  => 'text/tab-separated-value', 
			'etx'  => 'text/x-setext', 
			
			'eml'  => 'message/rfc822', 
			'nws'  => 'message/rfc822', 
			
			'bmp'  => 'image/bmp', 
			'pcx'  => 'image/bmp', 
			'gif'  => 'image/gif', 
			'ief'  => 'image/ief', 
			'jpeg' => 'image/jpeg', 
			'jpg'  => 'image/jpeg', 
			'jpe'  => 'image/jpeg', 
			'png'  => 'image/png', 
			'tiff' => 'image/tiff', 
			'tif'  => 'image/tiff', 
			'cmu'  => 'image/x-cmu-raster', 
			'pnm'  => 'image/x-portable-anymap', 
			'pbm'  => 'image/x-portable-bitmap', 
			'pgm'  => 'image/x-portable-graymap', 
			'ppm'  => 'image/x-portable-pixmap', 
			'rgb'  => 'image/x-rgb', 
			'xbm'  => 'image/x-xbitmap', 
			'xpm'  => 'image/x-xpixmap', 
			'xwd'  => 'image/x-xwindowdump', 
			
			'dwg'  => 'application/acad', 
			'ccad' => 'application/clariscad', 
			'drw'  => 'application/drafting', 
			'dxf'  => 'application/dxf', 
			'xls'  => 'application/excel', 
			'hdf'  => 'application/hdf', 
			'unv'  => 'application/i-deas', 
			'igs'  => 'application/iges', 
			'iges' => 'application/iges', 
			'doc'  => 'application/msword', 
			'dot'  => 'application/msword', 
			'wrd'  => 'application/msword', 
			'oda'  => 'application/oda', 
			'pdf'  => 'application/pdf', 
			'ppt'  => 'application/powerpoint', 
			'ai'   => 'application/postscript', 
			'eps'  => 'application/postscript', 
			'ps'   => 'application/postscript', 
			'rtf'  => 'application/rtf', 
			'rm'   => 'application/vnd.rn-realmedia', 
			'dvi'  => 'application/x-dvi', 			
			'gtar' => 'application/x-gtar', 
			'tgz'  => 'application/x-gtar', 
			'swf'  => 'application/x-shockwave-flash', 
			'tar'  => 'application/x-tar', 
			'gz'   => 'application/x-gzip-compressed', 
			'zip'  => 'application/x-zip-compressed', 
			
			'au'   => 'audio/basic', 
			'snd'  => 'audio/basic', 
			'aif'  => 'audio/x-aiff', 
			'aiff' => 'audio/x-aiff', 
			'aifc' => 'audio/x-aiff', 			
			'wma'  => 'audio/x-ms-wma', 
			
			'mpeg' => 'video/mpeg', 
			'mpg'  => 'video/mpeg', 
			'mpe'  => 'video/mpeg', 
			'mov'  => 'video/quicktime', 
			'avi'  => 'video/msvideo', 
			'movie'=> 'video/x-sgi-movie', 
			
		  	'unknow' => 'application/octet-stream', 
		  //'unknow' => 'application/x-unknown-content-type' 
		);
		
		return ( !empty($mime_type_ary[$ext]) ) ? $mime_type_ary[$ext] : $mime_type_ary['unknow']; 
	}
	
	/*
	 * Mailer : set_reply_to()
	 * 
	 * @param string $email_reply	: email de rponse
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function set_reply_to($email_reply = '')
	{
		if( $email_reply == '' )
		{
			$email_reply = $this->from['email']; 
		}
		
		$this->headers['Reply-To'] = '<' . $email_reply . '>'; 
	}
	
	/*
	 * Mailer : set_return_path()
	 * 
	 * @param string $email_return	: email de retour d'erreur
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function set_return_path($email_return = '')
	{
		if( $email_return == '' )
		{
			$email_return = $this->from['email']; 
		}
		
		$this->headers['Return-Path'] = $email_return; 
	}
	
	/*
	 * Mailer : set_notify()
	 * 
	 * @param string $email_notify	: email pour le retour de notification de lecture 
	 * 						  		  (par dfaut, l'adresse d'envoi est utilise)
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function set_notify($email_notify = '')
	{
		if( $email_notify == '' )
		{
			$email_notify = $this->from['email']; 
		}
		
		$this->headers['Disposition-Notification-To'] = '<' . $email_notify . '>'; 
	}
	
	/*
	 * Mailer : organization()
	 * 
	 * @param string $soc
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function organization($soc)
	{
		$this->headers['Organization'] = $soc; 
	}
	
	/*
	 * Mailer : set_priority()
	 * 
	 * @param string ou integer $level : Niveau de priorit de l'email
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function set_priority($level)
	{
		if( is_numeric($level) )
		{
			if( $level > 0 && $level <= 5 )
			{
				$this->headers['X-Priority'] = $level; 
			}
		}
		else
		{
			$level = strtolower($level); 
			
			switch( $level )
			{
				case 'highest':
					$this->headers['X-MSMail-Priority'] = 'Highest';
					break;
				
				case 'hight':
					$this->headers['X-MSMail-Priority'] = 'High';
					break;
				
				case 'low':
					$this->headers['X-MSMail-Priority'] = 'Low';
					break;
				
				case 'lowest':
					$this->headers['X-MSMail-Priority'] = 'Lowest';
					break;
				
				case 'normal':
				default:
					$this->headers['X-MSMail-Priority'] = 'Normal';
					break;
			}
		}
	}
	
	/*
	 * Mailer : set_header()
	 * 
	 * @param string $header : Nom de l'entte  modifier
	 * @param string $str	 : Contenu de l'entte
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function set_header($header, $str)
	{
		if( $header != '' && $str != '' )
		{
			if( strpos($header, '-') )
			{
				$elt = explode('-', $header);
				
				$item = array(); 
				foreach( $elt AS $val )
				{
					$item[] = ucfirst($val); 
				}
				
				$header = implode('-', $item); 
			}
			else
			{
				$header = ucfirst($header);
			}
			
			$this->headers[$header] = $str;
		}
	}
	
	/*
	 * Mailer : set_format()
	 * 
	 * @param string/integer $format : Format de l'email
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function set_format($format)
	{
		if( !is_numeric($format) )
		{
			$format = strtolower($format); 
		}		
		
		switch( $format )
		{
			case 'alt':
			case 3:
				$this->format = 3; 
				break;
			
			case 'html':
			case 'htm':
			case 2:
				$this->format = 2;
				break;
			
			case 'texte':
			case 'txt':
			case 'text':
			case 1:
			default:
				$this->format = 1;
				break;
		}
	}
	
	/*
	 * Mailer : send()
	 * 
	 * @param boolean $do_not_send	: true -> affiche l'entte et le corp du message au lieu de l'envoyer 
	 * 
	 * @access public
	 * 
	 * @return boolean
	 */
	function send($do_not_send = false)
	{
		if( $this->from['email'] == '' )
		{
			$this->error('send()', "Aucune adresse expditrice indique"); 
			return false;
		}
		
		if( !isset($this->headers['To']) )
		{
			$this->set_to($this->from['email']); 
		}
		
		if( $this->subject == '' )
		{
			$this->error('send()', "Aucun sujet spcifi"); 
			return false;
		}
		
		if( $this->uncompiled_message[$this->format] == '' )
		{
			$this->error('send()', "Aucun message spcifi"); 
			return false;
		}
		
		if( $this->format == 3 && $this->uncompiled_altmessage[$this->format] == '' )
		{
			$this->format = 2; 
			$this->uncompiled_message[$this->format] = $this->uncompiled_message[3]; 
		}
		
		if( !$this->smtp_mode )
		{
			$to_list = $this->headers['To']; 
		}
		
		$headers = $this->compile_headers(); 
		$message = $this->compile_message(); 
		
		$result = false; 
		
		$old_return_path = @ini_get('sendmail_from'); 
		@ini_set('sendmail_from', $this->headers['Return-Path']); 
		
		if( $this->statut )
		{
			if( $do_not_send )
			{
				echo nl2br(htmlentities($headers)) . '<br /><br />' . nl2br(htmlentities($message)); 
				exit; 
			}
			
			if( $this->smtp_mode )
			{
				$smtp = new Smtp($this->smtp_data['host'], $this->smtp_data['port'], $this->smtp_data['user'], $this->smtp_data['pass'], $this->server); 
				
				$result = $smtp->mailsmtp($this->address, $this->subject, $message, $headers, $this->from['email']); 
			}
			else
			{
				switch( $this->hebergeur )
				{
					case WM_HOST_OTHER:
						$result = @mail($to_list, $this->subject, $message, $headers); 
						break;
					
					case WM_HOST_ONLINE:
						$result = @email($this->from_online, $to_list, $this->subject, $message, $this->reply_online, $headers); 
						break;
					
					case WM_HOST_NEXEN:
						include_once('mail.inc'); 
						$result = @email($to_list, $this->subject, $message, $headers); 
						break;
					
					default:
						$this->error('send()', 'Aucune fonction d\'envoi n\'est dfinie'); 
						break;
				}
			}
		}
		
		@ini_set('sendmail_from', $old_return_path); 
		
		if( !$result && !empty($php_errormsg) )
		{
			$this->error('send()', $php_errormsg); 
		}
		
		return $result; 
	}
	
	/*
	 * Mailer : compile_headers()
	 * 
	 * @access private
	 * 
	 * @return string
	 */
	function compile_headers()
	{
		global $HTTP_SERVER_VARS, $HTTP_ENV_VARS; 
		
		if( $this->hebergeur == WM_HOST_ONLINE && !$this->smtp_mode )
		{
			list($account) = explode('@', $this->from['email']); 
			$this->from_online = $this->reply_online = $account; 
			
			unset($this->headers['From'], $this->headers['Reply-To'], $this->headers['X-Sender']); 
		}
		
		if( $this->server == 'localhost' )
		{
			if( !empty($HTTP_SERVER_VARS['HTTP_HOST']) || !empty($HTTP_ENV_VARS['HTTP_HOST']) )
			{
				$server = ( !empty($HTTP_SERVER_VARS['HTTP_HOST']) ) ? $HTTP_SERVER_VARS['HTTP_HOST'] : $HTTP_ENV_VARS['HTTP_HOST'];
			}
			else if( !empty($HTTP_SERVER_VARS['SERVER_NAME']) || !empty($HTTP_ENV_VARS['SERVER_NAME']) )
			{
				$server = ( !empty($HTTP_SERVER_VARS['SERVER_NAME']) ) ? $HTTP_SERVER_VARS['SERVER_NAME'] : $HTTP_ENV_VARS['SERVER_NAME'];
			}		
			else
			{
				$server = '';
			}
			
			$this->server = ( $server != '' ) ? $server : $this->server; 
		}
		
		$sender_ip = ( !empty($HTTP_SERVER_VARS['REMOTE_ADDR']) ) ? $HTTP_SERVER_VARS['REMOTE_ADDR'] : ( ( !empty($HTTP_ENV_VARS['REMOTE_ADDR']) ) ? $HTTP_ENV_VARS['REMOTE_ADDR'] : '127.0.0.1' ); 
		
		$this->headers['X-Mailer']		= "WAmailer/" . $this->version . " PHP/" . phpversion(); 
		$this->headers['X-AntiAbuse']	= "Sender IP - $sender_ip Server Name - <" . $this->server . ">"; 
		$this->headers['Date']			= date('D, d M Y H:i:s O', time()); 
		$this->headers['MIME-Version']	= '1.0'; 
		
		if( $this->compiled_message[$this->format] == '' )
		{
			$this->boundary['part0'] = '-----=_Part0_' . md5( uniqid ( rand() ) ); 
			$this->boundary['part1'] = '-----=_Part1_' . md5( uniqid ( rand() ) ); 
			$this->boundary['part2'] = '-----=_Part2_' . md5( uniqid ( rand() ) ); 
		}
		
		switch( $this->format )
		{
			case 3:
				$this->headers['Content-Type'] = "multipart/alternative;\n\tboundary=\"" . $this->boundary['part2'] . '"'; 
				break;
			
			case 2:
				$this->headers['Content-Type'] = "text/html; charset=\"" . $this->charset . '"'; 
				$this->headers['Content-Transfer-Encoding'] = $this->encoding; 
				break;
			
			case 1:
				$this->headers['Content-Type'] = "text/plain; charset=" . $this->charset; 
				$this->headers['Content-Transfer-Encoding'] = $this->encoding; 
				break;
			
			default:
				$this->error('compile_headers()', 'format inconnu'); 
				break;
		}
		
		$total_attach	= count($this->attachfile['path']); 
		$total_embedded	= count($this->embeddedfile['path']); 
		
		if( $total_embedded > 0 && $this->format > 1 )
		{
			$this->headers['Content-Type'] = "multipart/related;\n\t"; 
			
			if( $this->format == 3 )
			{
				$this->headers['Content-Type'] .= "type=\"multipart/alternative\";\n\t"; 
			}
			
			$this->headers['Content-Type'] .= 'boundary="' . $this->boundary['part1'] . '"'; 
			
			$this->headers['Content-Transfer-Encoding'] = ''; 
		}
		else if( $total_embedded > 0 )
		{
			for( $i = 0; $i < $total_embedded; $i++ )
			{
				$this->attachfile['path'][] 		= $this->embeddedfile['path'][$i]; 
				$this->attachfile['name'][]			= $this->embeddedfile['name'][$i]; 
				$this->attachfile['mimetype'][] 	= $this->embeddedfile['mimetype'][$i]; 
				$this->attachfile['disposition'][]	= 'attachment'; 
				
				$total_attach++; 
			}
		}
		
		if( $total_attach > 0 )
		{
			$this->headers['Content-Type'] = "multipart/mixed;\n\tboundary=\"" . $this->boundary['part0'] . '"'; 
			$this->headers['Content-Transfer-Encoding'] = ''; 
		}
		
		$headers = ''; 
		foreach( $this->headers AS $title_header => $content_header )
		{
			if( ( !$this->smtp_mode && ( $title_header == 'Subject' || $title_header == 'To' ) ) || 
				( $this->smtp_mode && $title_header == 'Bcc' ) || $content_header == '' )
			{
				continue;
			}
			
			$headers .= ( $headers != '' ) ? "\n" : ''; 
			$headers .= $title_header . ': ' . $content_header; 
		}
		
		return $headers; 
	}
	
	/*
	 * Mailer : compile_message()
	 * 
	 * @access private
	 * 
	 * @return string
	 */
	function compile_message()
	{
		$f = $this->format; 
		
		if( $this->compiled_message[$f] == '' )
		{
			$total_attach	= count($this->attachfile['path']); 
			$total_embedded	= count($this->embeddedfile['path']); 
			
			$this->compiled_message[$f] = '{WAMAILER_MSG}'; 
			
			if( $total_embedded > 0 && $f > 1 )
			{
				$tmp_msg = $this->compiled_message[$f]; 
				
				$this->compiled_message[$f] = '--' . $this->boundary['part1'] . "\n"; 
				
				switch( $f )
				{
					case 3:
						$this->compiled_message[$f] .= "Content-Type: multipart/alternative;\n\tboundary=\"" . $this->boundary['part2'] . "\"\n\n"; 
						break;
					
					case 2:
						$this->compiled_message[$f] .= 'Content-Type: text/html; charset="' . $this->charset . "\"\n"; 
						$this->compiled_message[$f] .= 'Content-Transfer-Encoding: ' . $this->encoding . "\n\n"; 
						break;
					
					case 1:
						$this->compiled_message[$f] .= 'Content-Type: text/plain; charset=' . $this->charset . "\n"; 
						$this->compiled_message[$f] .= 'Content-Transfer-Encoding: ' . $this->encoding . "\n\n"; 
						break;
					
					default:
						$this->error('compile_message()', 'format inconnu'); 
						break;
				}
				
				$this->compiled_message[$f] .= $tmp_msg; 
				$this->compiled_message[$f] .= "\n\n"; 
				
				for( $i = 0; $i < $total_embedded; $i++ )
				{
					$this->insert_attach(
						$this->embeddedfile['path'][$i],
						$this->embeddedfile['name'][$i],
						$this->embeddedfile['mimetype'][$i],
						'attachment',
						$this->boundary['part1'],
						TRUE
					); 
				}
				
				$this->compiled_message[$f] .= '--' . $this->boundary['part1'] . "--\n"; 
			}
			
			if( $total_attach > 0 )
			{
				$tmp_msg = $this->compiled_message[$f]; 
				
				$this->compiled_message[$f] = '--' . $this->boundary['part0'] . "\n"; 
				
				if( $total_embedded > 0 && $f > 1 )
				{
					$this->compiled_message[$f] .= "Content-Type: multipart/related;\n\t"; 
					
					if( $this->format == 3 )
					{
						$this->compiled_message[$f] .= "type=\"multipart/alternative\";\n\t"; 
					}
					
					$this->compiled_message[$f] .= 'boundary="' . $this->boundary['part1'] . "\"\n\n"; 
				}
				else
				{
					switch( $f )
					{
						case 3:
							$this->compiled_message[$f] .= "Content-Type: multipart/alternative;\n\tboundary=\"" . $this->boundary['part2'] . "\"\n\n"; 
							break;
						
						case 2:
							$this->compiled_message[$f] .= 'Content-Type: text/html; charset="' . $this->charset . "\"\n"; 
							$this->compiled_message[$f] .= 'Content-Transfer-Encoding: ' . $this->encoding . "\n\n"; 
							break;
						
						case 1:
							$this->compiled_message[$f] .= 'Content-Type: text/plain; charset=' . $this->charset . "\n"; 
							$this->compiled_message[$f] .= 'Content-Transfer-Encoding: ' . $this->encoding . "\n\n"; 
							break;
						
						default:
							$this->error('compile_message()', 'format inconnu'); 
							break;
					}
				}
				
				$this->compiled_message[$f] .= $tmp_msg; 
				$this->compiled_message[$f] .= "\n\n"; 
				
				for( $i = 0; $i < $total_attach; $i++ )
				{
					$this->insert_attach(
						$this->attachfile['path'][$i],
						$this->attachfile['name'][$i],
						$this->attachfile['mimetype'][$i],
						$this->attachfile['disposition'][$i],
						$this->boundary['part0'],
						FALSE
					); 
				}
				
				$this->compiled_message[$f] .= '--' . $this->boundary['part0'] . "--\n"; 
			}
			
			if( $f == 3 || $total_attach > 0 || ( $total_embedded > 0 && $f > 1 ) )
			{
				$this->compiled_message[$f] = "This is a multi-part message in MIME format.\n\n" . $this->compiled_message[$f]; 
			}
		}
		
		if( $f == 3 )
		{
			$message  = '--' . $this->boundary['part2'] . "\n"; 
			$message .= 'Content-Type: text/plain; charset=' . $this->charset . "\n"; 
			$message .= 'Content-Transfer-Encoding: ' . $this->encoding . "\n\n"; 
			$message .= $this->make_encoding($this->encoding, $this->replace_tags($this->uncompiled_altmessage[$f])); 
			$message .= "\n\n"; 
			$message .= '--' . $this->boundary['part2'] . "\n"; 
			$message .= 'Content-Type: text/html; charset="' . $this->charset . "\"\n"; 
			$message .= 'Content-Transfer-Encoding: ' . $this->encoding . "\n\n"; 
			$message .= $this->make_encoding($this->encoding, $this->replace_tags($this->uncompiled_message[$f])); 
			$message .= "\n\n"; 
			$message .= '--' . $this->boundary['part2'] . "--\n"; 
		}
		else
		{
			$message = $this->make_encoding($this->encoding, $this->replace_tags($this->uncompiled_message[$f])); 
		}
		
		return str_replace('{WAMAILER_MSG}', $message, $this->compiled_message[$f]); 
	}
	
	function insert_attach($path, $filename, $mime_type, $disposition, $boundary, $embedded)
	{
		$f = $this->format; 
		
		if( $mime_type == '' )
		{
			$extension = 'wa'; 
			if( $pos = strrpos($filename, '.') )
			{
				$extension = strtolower(substr($filename, ($pos + 1))); 
			}
			
			$mime_type = $this->mime_type($extension); 
		}
		
		$this->compiled_message[$f] .= '--' . $boundary . "\n"; 
		$this->compiled_message[$f] .= 'Content-Type: ' . $mime_type . ";\n\tname=\"" . $filename . "\"\n"; 
		$this->compiled_message[$f] .= "Content-Transfer-Encoding: base64\n"; 
		
		if( $embedded && $f > 1 )
		{
			$cid = $this->generate_cid(); 
			
			$this->compiled_message[$f] .= 'Content-ID: <' . $cid . ">\n\n"; 
			
			$this->uncompiled_message[$f] = preg_replace(
				'/<([^<]+)"cid:' . preg_quote($filename, '/') . '"([^>]*)?>/i',
				'<\\1"cid:' . $cid . '"\\2>',
				$this->uncompiled_message[$f]
			); 
		}
		else
		{
			$this->compiled_message[$f] .= 'Content-Disposition: ' . $disposition . ";\n\tfilename=\"" . $filename . "\"\n\n"; 
		}
		
		$this->compiled_message[$f] .= $this->make_encoding('base64', $this->loadfile($path, true)); 
		$this->compiled_message[$f] .= "\n\n"; 
	}
	
	/*
	 * Mailer : clear_all()
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function clear_all()
	{
		$this->format				= 1; 
		$this->from					= array('email' => '', 'name' => ''); 
		$this->from_online			= ''; 
		$this->reply_online 		= ''; 
		$this->address				= array(); 
		$this->subject 				= ''; 
		$this->uncompiled_message	= ''; 
		$this->uncompiled_altmessage= ''; 
		$this->compiled_message		= array(); 
		$this->tags					= array(); 
		$this->boundary				= array('part0' => '', 'part1' => '', 'part2' => ''); 
		$this->attachfile 			= array('path' => array(), 'name' => array(), 'mimetype' => array(), 'disposition' => array());
		$this->embeddedfile 		= array('path' => array(), 'name' => array(), 'mimetype' => array(), 'cid' => array());
		$this->headers 				= array();		
		$this->mail_reponse 		= '';
		$this->statut 				= true; 
	}
	
	/*
	 * Mailer : clear_from()
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function clear_from()
	{
		$this->from_online		= ''; 
		$this->reply_online		= ''; 
		$this->from				= array('email' => '', 'name' => ''); 
		$this->mail_reponse		= ''; 
		$this->statut 			= true; 
	}
	
	/*
	 * Mailer : clear_to()
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function clear_to()
	{
		$this->address			= array(); 
		$this->mail_reponse		= ''; 
		$this->statut 			= true; 
		
		unset($this->headers['To'], $this->headers['Cc'], $this->headers['Bcc']); 
	}
	
	/*
	 * Mailer : clear_subject()
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function clear_subject()
	{
		$this->subject 			= ''; 
		$this->mail_reponse		= ''; 
		$this->statut 			= true; 
	}
	
	/*
	 * Mailer : clear_message()
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function clear_message()
	{
		$this->uncompiled_message	= ''; 
		$this->uncompiled_altmessage= ''; 
		$this->compiled_message		= array(); 
		$this->tags					= array(); 
		$this->boundary				= array('part0' => '', 'part1' => '', 'part2' => ''); 
		$this->mail_reponse 		= ''; 
		$this->statut 				= true; 
	}
	
	/*
	 * Mailer : clear_attach()
	 * 
	 * @access public
	 * 
	 * @return void
	 */
	function clear_attach()
	{
		$this->attachfile 			= array('path' => array(), 'name' => array(), 'mimetype' => array(), 'disposition' => array());
		$this->embeddedfile 		= array('path' => array(), 'name' => array(), 'mimetype' => array(), 'cid' => array());
		$this->mail_reponse 		= ''; 
		$this->statut 				= true; 
	}
	
	/*
	 * Mailer : error()
	 * 
	 * @param string $fct 	: La dernire fonction o s'est produite l'erreur
	 * @param string $error : Le message d'erreur  afficher si mode debug
	 * 
	 * @access private
	 * 
	 * @return void
	 */
	function error($fct, $error)
	{
		if( $this->mail_reponse == '' )
		{
			$this->mail_reponse = '<br />'; 
		}
		
		$this->mail_reponse .= sprintf("<br />%s <b>Erreur</b> : %s", $fct, $error); 
		
		$this->statut = false; 
		
		if( $this->debug )
		{
			exit($this->mail_reponse); 
		}
	}	
}// fin de la classe

class Smtp extends Mailer {
	
	/*
	 * Les sources qui m'ont bien aides : 
	 * 
	 * @link : http://www.rfc-editor.org/
	 * @link : http://strasbourg.ort.asso.fr/examen2000/np.html#SMTP
	 * @link : http://www.commentcamarche.net/internet/smtp.php3
	 * @link : http://abcdrfc.free.fr/
	 * @link : http://www.interpc.fr/mapage/billaud/telmail.htm
	 *
	 * Toutes les commandes de connexion et de dialogue avec le serveur sont 
	 * dtailles dans la RFC 821.
	 * 
	 * Les commandes d'authentification au serveur sont dtailles dans 
	 * la RFC 2554 ( note: Impossible de trouver cette fichu RFC 2554 en franais ou 
	 * de trouver des infos satisfaisantes sur la commande AUTH ).
	 * 
	 * @link : http://www.rfc-editor.org/rfc/rfc2554.txt
	 * 
	 */	
	
	/*
     * Identifiant de connexion
     *
     * @var	(resource)	$connect_id
	 * 
	 * @access private
     */
	var $connect_id		= ''; 
	
	/*
	 * Mailer : smtp()
	 * 
	 * @param (string)	$smtp_server	: Nom du serveur smtp 
	 * @param (integer) $smtp_port		: Numro du port smtp 
	 * @param (string)	$smtp_user		: Nom d'utilisateur (Si AUTH autoris) 
	 * @param (string)	$smtp_pass		: Mot de passe (Si AUTH autoris) 
	 * @param (string)	$server_from	: Nom du serveur metteur 
	 * 
	 * @access private
	 * 
	 * @return boolean
	 */
	function smtp($smtp_server, $smtp_port, $smtp_user, $smtp_pass, $server_from)
	{
		if( !is_resource($this->connect_id) )
		{
			$result = $this->connect_to_smtp($smtp_server, $smtp_port, $smtp_user, $smtp_pass, $server_from); 
			
			if( $result['error'] )
			{
				$this->error('connect_to_smtp()', $result['message']); 
				return false; 
			}
			
			$this->connect_id = $result['connect_id']; 
		}
		
		return true; 
	}
	
	/*
	 * Mailer : connect_to_smtp()
	 * 
	 * @param (string)	$smtp_server	: Nom du serveur smtp 
	 * @param (integer) $smtp_port		: Numro du port smtp 
	 * @param (string)	$smtp_user		: Nom d'utilisateur (Si AUTH autoris) 
	 * @param (string)	$smtp_pass		: Mot de passe (Si AUTH autoris) 
	 * @param (string)	$server_from	: Nom du serveur metteur 
	 * 
	 * @access private
	 * 
	 * @return array
	 */
	function connect_to_smtp($smtp_server, $smtp_port, $smtp_user, $smtp_pass, $server_from)
	{
		// Ouverture de la connexion au serveur SMTP
		if( !($connect_id = @fsockopen($smtp_server, $smtp_port, $errno, $errstr, 2)) )
		{
			return array('error' => true, 'message' => "Echec lors de la connexion au serveur smtp : $errno $errstr"); 
		}
		
		// 
		// Code success : 220
		// Code failure : 421
		// 
		$result = send_data($connect_id, '', 220); 
		if( $result['error'] )
		{
			return array('error' => true, 'message' => $result['message']); 
		}
		
		// 
		// Comme on est poli, on dit bonjour, et on s'authentifie le cas chant 
		// 
		// Code success	: 250
        // Code error	: 500, 501, 504, 421
		//
		
		if( !empty($smtp_user) && !empty($smtp_pass) )
		{
			$result = send_data($connect_id, "EHLO $server_from\r\n", 250); 
			if( $result['error'] )
			{
				return array('error' => true, 'message' => $result['message']); 
			}
			
			$result = send_data($connect_id, "AUTH LOGIN\r\n", 334); 
			if( $result['error'] )
			{
				return array('error' => true, 'message' => $result['message']); 
			}
			
			$result = send_data($connect_id, base64_encode($smtp_user) . "\r\n", 334); 
			if( $result['error'] )
			{
				return array('error' => true, 'message' => $result['message']); 
			}
			
			$result = send_data($connect_id, base64_encode($smtp_pass) . "\r\n", 235); 
			if( $result['error'] )
			{
				return array('error' => true, 'message' => $result['message']); 
			}
		}
		else
		{
			$result = send_data($connect_id, "HELO $server_from\r\n", 250); 
			if( $result['error'] )
			{
				return array('error' => true, 'message' => $result['message']); 
			}
		}
		
		return array('error' => false, 'connect_id' => $connect_id); 
	}
	
	/*
	 * Mailer : mailsmtp()
	 *
	 * Description : Envoi d'emails via connexion au serveur smtp dfini.
	 * 
	 * @param array $to			: tableau contenant la liste des adresses directe (to), la liste des 
	 * 							  copie (cc) et la liste des copies caches (bcc)
	 * @param string $subject 	: Le sujet de l'email
	 * @param string $message 	: Le message construit (fichier attach ou pas, etc...)
	 * @param array $headers 	: Le tableau contenant les entetes
	 * @param string $from 		: Adresse d'envoi 
	 * 
	 * @access private
	 * 
	 * @return boolean
	 */	
	function mailsmtp($address, $subject, $message, $headers, $from)
	{
		//
		// On spcifie l'adresse de l'expditeur
		//
		// Code success	: 250
        // Code failure	: 552, 451, 452
        // Code error	: 500, 501, 421
		//
		$result = send_data($this->connect_id, 'MAIL FROM: <' . $from . ">\r\n", 250); 
		if( $result['error'] )
		{
			$this->error('mailsmtp()', $result['message']); 
			return false; 
		}
		
		//
		// On spcifie les destinatires au serveur smtp
		//
		// Code success	: 250, 251
        // Code failure	: 550, 551, 552, 553, 450, 451, 452
        // Code error	: 500, 501, 503, 421
		// 
		foreach( $address AS $email )
		{
			$result = send_data($this->connect_id, 'RCPT TO: <' . $email . ">\r\n", 250, 251); 
			if( $result['error'] )
			{
				$this->error('mailsmtp()', $result['message']); 
				return false; 
			}
		}
		
		//
		// On indique au serveur que l'on va lui livrer les donnes
		//
		// Code intermdiaire 	: 354
		//
		$result = send_data($this->connect_id, "DATA\r\n", 354); 
		if( $result['error'] )
		{
			$this->error('mailsmtp()', $result['message']); 
			return false; 
		}
		
		//
		// On envoie les enttes 
		//
		$headers = preg_replace("/(?<!\r)\n/si", "\r\n", $headers); 
		send_data($this->connect_id, $headers . "\r\n\r\n"); 
		
		//
		// Et maintenant le message 
		//
		$message = preg_replace("/(?<!\r)\n/si", "\r\n", $message); 
		send_data($this->connect_id, $message . "\r\n"); 

		//
		// On indique la fin de l'envoi de donnes au serveur
		//
		// Code success	: 250
        // Code failure	: 552, 554, 451, 452
        // Code error	: 500, 501, 503, 421
		//
		$result = send_data($this->connect_id, ".\r\n", 250); 
		if( $result['error'] )
		{
			$this->error('mailsmtp()', $result['message']); 
			return false; 
		}
		
		//
		// Comme on est poli, on dit aurevoir au serveur avec la commande adquat QUIT 
		//
		// Code success	: 221
        // Code failure	: 500
		//
		send_data($this->connect_id, "QUIT\r\n"); 
		
		fclose($this->connect_id); 
		
		$this->connect_id = ''; 
		
		return true; 
	}
	
}

/*
 * send_data()
 * 
 * @param resource $connect_id	: Identifiant de connexion au serveur 
 * @param integer $input 		: Les donnes  envoyer 
 * 
 * @access private
 * 
 * @return array
 */
function send_data($connect_id, $input)
{
	if( $input != '' )
	{
		fputs($connect_id, $input); 
	}
	
	$num_args = func_num_args(); 
	
	if( $num_args > 2 )
	{
		$code_accept = array(); 
		for( $i = 2; $i < $num_args; $i++ )
		{
			$arg = func_get_arg($i); 
			if( is_numeric($arg) )
			{
				$code_accept[] = $arg; 
			}
		}
		
		$output = ''; 
		while( substr($output, 3, 1) != ' ' )
		{
			$output = fgets($connect_id, 512); 
			
			//echo $output . '<br>';  flush(); 
		}
		
		$error = false; 
		if( !in_array(substr($output, 0, 3), $code_accept) )
		{
			$error = true; 
		}
		
		return array('error' => $error, 'message' => 'SMTP Error : ' . nl2br(htmlentities($output))); 
	}
	
	return array('error' => false); 
}

}
?>